FlameWarden = {}
local events, achievementIDs, flameQuests, flameZones = CreateFrame("Frame", "FlameWardenEventTracker")

local function init()
	flameQuests, flameZones, achievementIDs = {}, {}, {}
	for i=1,GetCategoryNumAchievements(161) do
		local id, name, _, _, _, _, _, _, _, tex = GetAchievementInfo(161, i)
		if tex == "Interface\\Icons\\Spell_Fire_MasterOfElements" or tex == "Interface\\Icons\\INV_SummerFest_FireSpirit" then
			local zp, u = (tex == "Interface\\Icons\\Spell_Fire_MasterOfElements" and "*" or ""), false
			for i=1,GetAchievementNumCriteria(id) do
				local zone, ctype, _, _, _, _, _, aid = GetAchievementCriteriaInfo(id, i)
				if ctype == 27 then
					flameZones[zp .. zone], flameQuests[aid], achievementIDs[id] = true, zp .. zone, zp == "*" and 1 or 0
				end
			end
		end
	end
	return true
end
local getQuestReward do
	local pat = "^" .. ERR_QUEST_REWARD_ITEM_MULT_IS:gsub("%.", "%%."):gsub("%%0?1?$?d", "(%%d+)"):gsub("%%0?2?$?s", "(.-)") .. "$"
	function getQuestReward(message)
		local quant, link = message:match(pat)
		if not quant then return end
		if quant:match("%D") and not link:match("|Hitem:") then
			quant, link = link, quant
		end
		return tonumber(quant), tonumber(link:match("|Hitem:(%d+)"))
	end
end

function FlameWarden.GetZoneState(zone)
	if not flameQuests then init() end
	zone = zone or GetRealZoneText()
	local zd = "*" .. tostring(zone)
	return FlameWardenLog and FlameWardenLog[zone] or (flameZones[zone] and 0), FlameWardenLog and FlameWardenLog[zd] or (flameZones[zd] and 0)
end
function FlameWarden.GetCriteriaState(id)
	if not flameQuests then init() end
	local zone = flameQuests[id]
	return FlameWardenLog and FlameWardenLog[zone]
end
function FlameWarden.AchievementType(id)
	return (achievementIDs or init()) and achievementIDs[id]
end
function FlameWarden.Update(zoneFlag)
	FlameWardenLog = FlameWardenLog or {}
	FlameWardenLog[zoneFlag] = select(4, CalendarGetDate())
end

local questID
function events:CHAT_MSG_SYSTEM(message)
	if (flameQuests or init()) and not flameQuests[questID] then return end
	local z, quant, id = flameQuests[questID], getQuestReward(message)
	if id == 23247 and z then
		questID = nil
		FlameWarden.Update(z)
	end
end
function events:QUEST_COMPLETE()
	questID = GetQuestID()
end
function events:QUEST_QUERY_COMPLETE()
	if not flameQuests then init() end
	local quests = GetQuestsCompleted()
	for k,v in pairs(flameQuests) do
		if quests[k] then
			FlameWarden.Update(v)
		end
	end
	FlameWardenLog = FlameWardenLog or {}
	FlameWardenLog.__LastQueriedYear = select(4, CalendarGetDate())
end
for k,v in pairs(events) do
	if type(v) == "function" then
		events:RegisterEvent(k)
	end
end

events:SetScript("OnEvent", function(s,e,...) s[e](s, ...) end)